/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "clock.h"

unsigned char ss	= 0; //Variable fr Sekunden
unsigned char mm	= 21;//Variable fr Minuten
unsigned char hh	= 22;//Variable fr Stunden

#if USE_CLOCK

//############################################################################
//Diese Routine addiert 1Sekunde wenn Timer Interrupt ausgel�t wird 
SIGNAL (SIG_OVERFLOW1)
//############################################################################
{
	TCNT1 = 65535 - (SYSCLK / 1024);
#if USE_MCA25_CAM
	if ((ss&0x01)==1){
		MCA25_CLOCK_LED_ON();
	}else{
		MCA25_CLOCK_LED_OFF();
	}
#endif	
#if USE_WDT
	wdt_reset();
#endif
	ss++;//Addiere +1
	if (ss == 60)
		{
		ss = 0;
		mm++;//Addiere +1
		if (mm == 60)
			{
			mm = 0;
			hh++;//Addiere +1
			if (hh == 24)
				{
				hh = 0;
				}
			}
		}
}


//############################################################################
//Diese Routine startet und inizialisiert den Timer
void Start_Clock (void)
//############################################################################
{
	//Interrupt for the Clock enable
	timer_enable_int(_BV(TOIE1));
	//Setzen des Prescaler auf 1024 
	TCCR1B |= (1<<CS10 | 0<<CS11 | 1<<CS12); 
	return;
}

#endif //#if USE_CLOCK

