/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _IP_H
 #define _IP_H

 #include "ethernet.h"

//Prototype
extern void Make_IP_Header (char *);

//Aufbau eines IP Datagramms (B=BIT)
//	
//4B Version	|4B Headergr.	|8B Tos	|16B Gesamtlnge in Bytes	
//16B Identifikation			|3B Schalter	|13B Fragmentierungsposition
//8B Time to Live	|8B Protokoll	|16B Header Prfsumme 
//32B IP Quelladresse
//32B IB Zieladresse
//
//*** Nutzlast ***

#define IP_OFFSET				0x0E

struct IP_Header	{
	unsigned char	IP_Vers_Len;	//4 BIT Die Versionsnummer von IP, 
									//meistens also 4 + 4Bit Headergre 	
	unsigned char	IP_Tos;			//Type of Service
	unsigned int	IP_Pktlen;		//16 Bit Komplette Lng des IP Datagrams in Bytes
	unsigned int	IP_Id;			//ID des Packet fr Fragmentierung oder 
									//Reassemblierung
	unsigned int	IP_Frag_Offset;	//wird benutzt um ein fragmentiertes 
									//IP Packet wieder korrekt zusammenzusetzen
	unsigned char	IP_ttl;			//8 Bit Time to Live die lebenszeit eines Paket
	unsigned char	IP_Proto;		//Zeigt das hherschichtige Protokoll an 
									//(TCP, UDP, ICMP)
	unsigned int	IP_Hdr_Cksum;	//Checksumme des IP Headers
	unsigned long	IP_Srcaddr;		//32 Bit IP Quelladresse
	unsigned long	IP_Destaddr;	//32 Bit IP Zieladresse
};


//IP Header Layout
#define	IP_VERS_LEN				IP_OFFSET+0x00	//4 BIT Die Versionsnummer von IP, 
												//meistens also 4 + 4Bit Headergre 	
#define	IP_PKTLEN				IP_OFFSET+0x02	//16 Bit Komplette Lng des IP Datagrams in Bytes
#define	IP_SRCADDR				IP_OFFSET+0x0C	//32 Bit IP Quelladresse	

//IP Protocol Types
#define	PROT_ICMP				0x01	//zeigt an die Nutzlasten enthalten das ICMP Prot
#define	PROT_TCP				0x06	//zeigt an die Nutzlasten enthalten das TCP Prot.
#define	PROT_UDP				0x11	//zeigt an die Nutzlasten enthalten das UDP Prot.

//Defines fr IF Abfrage
#define MyIP 			ip->IP_Destaddr==*((unsigned long *)&MYIP[0])
#define IP_UDP_Packet 	ip->IP_Proto == PROT_UDP
#define IP_TCP_Packet 	ip->IP_Proto == PROT_TCP
#define IP_ICMP_Packet 	ip->IP_Proto == PROT_ICMP

#endif //_IP_H

